module Text.Numerals.Languages.EnglishSpec (
    spec
  ) where

import Data.Text(Text)

import Test.Hspec(Spec)
import Text.Numerals.Languages.English(english)
import Text.Numerals.LanguageTest(testLanguage)

spec :: Spec
spec = testLanguage "English" english cardinals ordinals

cardinals :: [(Integer, Text)]
cardinals = [
    (0, "zero")
  , (1, "one")
  , (2, "two")
  , (3, "three")
  , (4, "four")
  , (5, "five")
  , (6, "six")
  , (7, "seven")
  , (8, "eight")
  , (9, "nine")
  , (10, "ten")
  , (11, "eleven")
  , (12, "twelve")
  , (13, "thirteen")
  , (14, "fourteen")
  , (15, "fifteen")
  , (16, "sixteen")
  , (17, "seventeen")
  , (18, "eighteen")
  , (19, "nineteen")
  , (20, "twenty")
  , (21, "twenty-one")
  , (22, "twenty-two")
  , (23, "twenty-three")
  , (24, "twenty-four")
  , (25, "twenty-five")
  , (26, "twenty-six")
  , (27, "twenty-seven")
  , (28, "twenty-eight")
  , (29, "twenty-nine")
  , (30, "thirty")
  , (31, "thirty-one")
  , (32, "thirty-two")
  , (33, "thirty-three")
  , (34, "thirty-four")
  , (35, "thirty-five")
  , (36, "thirty-six")
  , (37, "thirty-seven")
  , (38, "thirty-eight")
  , (39, "thirty-nine")
  , (40, "forty")
  , (41, "forty-one")
  , (42, "forty-two")
  , (43, "forty-three")
  , (44, "forty-four")
  , (45, "forty-five")
  , (46, "forty-six")
  , (47, "forty-seven")
  , (48, "forty-eight")
  , (49, "forty-nine")
  , (50, "fifty")
  , (51, "fifty-one")
  , (52, "fifty-two")
  , (53, "fifty-three")
  , (54, "fifty-four")
  , (55, "fifty-five")
  , (56, "fifty-six")
  , (57, "fifty-seven")
  , (58, "fifty-eight")
  , (59, "fifty-nine")
  , (60, "sixty")
  , (61, "sixty-one")
  , (62, "sixty-two")
  , (63, "sixty-three")
  , (64, "sixty-four")
  , (65, "sixty-five")
  , (66, "sixty-six")
  , (67, "sixty-seven")
  , (68, "sixty-eight")
  , (69, "sixty-nine")
  , (70, "seventy")
  , (71, "seventy-one")
  , (72, "seventy-two")
  , (73, "seventy-three")
  , (74, "seventy-four")
  , (75, "seventy-five")
  , (76, "seventy-six")
  , (77, "seventy-seven")
  , (78, "seventy-eight")
  , (79, "seventy-nine")
  , (80, "eighty")
  , (81, "eighty-one")
  , (82, "eighty-two")
  , (83, "eighty-three")
  , (84, "eighty-four")
  , (85, "eighty-five")
  , (86, "eighty-six")
  , (87, "eighty-seven")
  , (88, "eighty-eight")
  , (89, "eighty-nine")
  , (90, "ninety")
  , (91, "ninety-one")
  , (92, "ninety-two")
  , (93, "ninety-three")
  , (94, "ninety-four")
  , (95, "ninety-five")
  , (96, "ninety-six")
  , (97, "ninety-seven")
  , (98, "ninety-eight")
  , (99, "ninety-nine")
  , (100, "one hundred")
  , (101, "one hundred and one")
  , (102, "one hundred and two")
  , (103, "one hundred and three")
  , (104, "one hundred and four")
  , (105, "one hundred and five")
  , (106, "one hundred and six")
  , (107, "one hundred and seven")
  , (108, "one hundred and eight")
  , (109, "one hundred and nine")
  , (110, "one hundred and ten")
  , (111, "one hundred and eleven")
  , (112, "one hundred and twelve")
  , (113, "one hundred and thirteen")
  , (114, "one hundred and fourteen")
  , (115, "one hundred and fifteen")
  , (116, "one hundred and sixteen")
  , (117, "one hundred and seventeen")
  , (118, "one hundred and eighteen")
  , (119, "one hundred and nineteen")
  , (120, "one hundred and twenty")
  , (121, "one hundred and twenty-one")
  , (122, "one hundred and twenty-two")
  , (123, "one hundred and twenty-three")
  , (124, "one hundred and twenty-four")
  , (125, "one hundred and twenty-five")
  , (126, "one hundred and twenty-six")
  , (127, "one hundred and twenty-seven")
  , (128, "one hundred and twenty-eight")
  , (129, "one hundred and twenty-nine")
  , (130, "one hundred and thirty")
  , (131, "one hundred and thirty-one")
  , (132, "one hundred and thirty-two")
  , (133, "one hundred and thirty-three")
  , (134, "one hundred and thirty-four")
  , (135, "one hundred and thirty-five")
  , (136, "one hundred and thirty-six")
  , (137, "one hundred and thirty-seven")
  , (138, "one hundred and thirty-eight")
  , (139, "one hundred and thirty-nine")
  , (140, "one hundred and forty")
  , (141, "one hundred and forty-one")
  , (142, "one hundred and forty-two")
  , (143, "one hundred and forty-three")
  , (144, "one hundred and forty-four")
  , (145, "one hundred and forty-five")
  , (146, "one hundred and forty-six")
  , (147, "one hundred and forty-seven")
  , (148, "one hundred and forty-eight")
  , (149, "one hundred and forty-nine")
  , (150, "one hundred and fifty")
  , (151, "one hundred and fifty-one")
  , (152, "one hundred and fifty-two")
  , (153, "one hundred and fifty-three")
  , (154, "one hundred and fifty-four")
  , (155, "one hundred and fifty-five")
  , (156, "one hundred and fifty-six")
  , (157, "one hundred and fifty-seven")
  , (158, "one hundred and fifty-eight")
  , (159, "one hundred and fifty-nine")
  , (160, "one hundred and sixty")
  , (161, "one hundred and sixty-one")
  , (162, "one hundred and sixty-two")
  , (163, "one hundred and sixty-three")
  , (164, "one hundred and sixty-four")
  , (165, "one hundred and sixty-five")
  , (166, "one hundred and sixty-six")
  , (167, "one hundred and sixty-seven")
  , (168, "one hundred and sixty-eight")
  , (169, "one hundred and sixty-nine")
  , (170, "one hundred and seventy")
  , (171, "one hundred and seventy-one")
  , (172, "one hundred and seventy-two")
  , (173, "one hundred and seventy-three")
  , (174, "one hundred and seventy-four")
  , (175, "one hundred and seventy-five")
  , (176, "one hundred and seventy-six")
  , (177, "one hundred and seventy-seven")
  , (178, "one hundred and seventy-eight")
  , (179, "one hundred and seventy-nine")
  , (180, "one hundred and eighty")
  , (181, "one hundred and eighty-one")
  , (182, "one hundred and eighty-two")
  , (183, "one hundred and eighty-three")
  , (184, "one hundred and eighty-four")
  , (185, "one hundred and eighty-five")
  , (186, "one hundred and eighty-six")
  , (187, "one hundred and eighty-seven")
  , (188, "one hundred and eighty-eight")
  , (189, "one hundred and eighty-nine")
  , (190, "one hundred and ninety")
  , (191, "one hundred and ninety-one")
  , (192, "one hundred and ninety-two")
  , (193, "one hundred and ninety-three")
  , (194, "one hundred and ninety-four")
  , (195, "one hundred and ninety-five")
  , (196, "one hundred and ninety-six")
  , (197, "one hundred and ninety-seven")
  , (198, "one hundred and ninety-eight")
  , (199, "one hundred and ninety-nine")
  , (200, "two hundred")
  , (233, "two hundred and thirty-three")
  , (377, "three hundred and seventy-seven")
  , (610, "six hundred and ten")
  , (987, "nine hundred and eighty-seven")
  , (1597, "one thousand, five hundred and ninety-seven")
  , (2584, "two thousand, five hundred and eighty-four")
  , (4181, "four thousand, one hundred and eighty-one")
  , (6765, "six thousand, seven hundred and sixty-five")
  , (10946, "ten thousand, nine hundred and forty-six")
  , (17711, "seventeen thousand, seven hundred and eleven")
  , (28657, "twenty-eight thousand, six hundred and fifty-seven")
  , (46368, "forty-six thousand, three hundred and sixty-eight")
  , (75025, "seventy-five thousand and twenty-five")
  , (121393, "one hundred and twenty-one thousand, three hundred and ninety-three")
  , (196418, "one hundred and ninety-six thousand, four hundred and eighteen")
  , (317811, "three hundred and seventeen thousand, eight hundred and eleven")
  , (514229, "five hundred and fourteen thousand, two hundred and twenty-nine")
  , (832040, "eight hundred and thirty-two thousand and forty")
  , (1346269, "one million, three hundred and forty-six thousand, two hundred and sixty-nine")
  , (2178309, "two million, one hundred and seventy-eight thousand, three hundred and nine")
  , (3524578, "three million, five hundred and twenty-four thousand, five hundred and seventy-eight")
  , (5702887, "five million, seven hundred and two thousand, eight hundred and eighty-seven")
  , (9227465, "nine million, two hundred and twenty-seven thousand, four hundred and sixty-five")
  , (14930352, "fourteen million, nine hundred and thirty thousand, three hundred and fifty-two")
  , (24157817, "twenty-four million, one hundred and fifty-seven thousand, eight hundred and seventeen")
  , (39088169, "thirty-nine million, eighty-eight thousand, one hundred and sixty-nine")
  , (63245986, "sixty-three million, two hundred and forty-five thousand, nine hundred and eighty-six")
  , (102334155, "one hundred and two million, three hundred and thirty-four thousand, one hundred and fifty-five")
  , (165580141, "one hundred and sixty-five million, five hundred and eighty thousand, one hundred and forty-one")
  , (267914296, "two hundred and sixty-seven million, nine hundred and fourteen thousand, two hundred and ninety-six")
  , (433494437, "four hundred and thirty-three million, four hundred and ninety-four thousand, four hundred and thirty-seven")
  , (701408733, "seven hundred and one million, four hundred and eight thousand, seven hundred and thirty-three")
  , (1134903170, "one billion, one hundred and thirty-four million, nine hundred and three thousand, one hundred and seventy")
  , (1836311903, "one billion, eight hundred and thirty-six million, three hundred and eleven thousand, nine hundred and three")
  , (2971215073, "two billion, nine hundred and seventy-one million, two hundred and fifteen thousand and seventy-three")
  , (4807526976, "four billion, eight hundred and seven million, five hundred and twenty-six thousand, nine hundred and seventy-six")
  , (7778742049, "seven billion, seven hundred and seventy-eight million, seven hundred and forty-two thousand and forty-nine")
  , (12586269025, "twelve billion, five hundred and eighty-six million, two hundred and sixty-nine thousand and twenty-five")
  , (20365011074, "twenty billion, three hundred and sixty-five million, eleven thousand and seventy-four")
  , (32951280099, "thirty-two billion, nine hundred and fifty-one million, two hundred and eighty thousand and ninety-nine")
  , (53316291173, "fifty-three billion, three hundred and sixteen million, two hundred and ninety-one thousand, one hundred and seventy-three")
  , (86267571272, "eighty-six billion, two hundred and sixty-seven million, five hundred and seventy-one thousand, two hundred and seventy-two")
  , (139583862445, "one hundred and thirty-nine billion, five hundred and eighty-three million, eight hundred and sixty-two thousand, four hundred and forty-five")
  , (225851433717, "two hundred and twenty-five billion, eight hundred and fifty-one million, four hundred and thirty-three thousand, seven hundred and seventeen")
  , (365435296162, "three hundred and sixty-five billion, four hundred and thirty-five million, two hundred and ninety-six thousand, one hundred and sixty-two")
  , (591286729879, "five hundred and ninety-one billion, two hundred and eighty-six million, seven hundred and twenty-nine thousand, eight hundred and seventy-nine")
  , (956722026041, "nine hundred and fifty-six billion, seven hundred and twenty-two million, twenty-six thousand and forty-one")
  , (1548008755920, "one trillion, five hundred and forty-eight billion, eight million, seven hundred and fifty-five thousand, nine hundred and twenty")
  , (2504730781961, "two trillion, five hundred and four billion, seven hundred and thirty million, seven hundred and eighty-one thousand, nine hundred and sixty-one")
  , (4052739537881, "four trillion, fifty-two billion, seven hundred and thirty-nine million, five hundred and thirty-seven thousand, eight hundred and eighty-one")
  , (6557470319842, "six trillion, five hundred and fifty-seven billion, four hundred and seventy million, three hundred and nineteen thousand, eight hundred and forty-two")
  , (10610209857723, "ten trillion, six hundred and ten billion, two hundred and nine million, eight hundred and fifty-seven thousand, seven hundred and twenty-three")
  , (17167680177565, "seventeen trillion, one hundred and sixty-seven billion, six hundred and eighty million, one hundred and seventy-seven thousand, five hundred and sixty-five")
  , (27777890035288, "twenty-seven trillion, seven hundred and seventy-seven billion, eight hundred and ninety million, thirty-five thousand, two hundred and eighty-eight")
  , (44945570212853, "forty-four trillion, nine hundred and forty-five billion, five hundred and seventy million, two hundred and twelve thousand, eight hundred and fifty-three")
  , (72723460248141, "seventy-two trillion, seven hundred and twenty-three billion, four hundred and sixty million, two hundred and forty-eight thousand, one hundred and forty-one")
  , (117669030460994, "one hundred and seventeen trillion, six hundred and sixty-nine billion, thirty million, four hundred and sixty thousand, nine hundred and ninety-four")
  , (190392490709135, "one hundred and ninety trillion, three hundred and ninety-two billion, four hundred and ninety million, seven hundred and nine thousand, one hundred and thirty-five")
  , (308061521170129, "three hundred and eight trillion, sixty-one billion, five hundred and twenty-one million, one hundred and seventy thousand, one hundred and twenty-nine")
  , (498454011879264, "four hundred and ninety-eight trillion, four hundred and fifty-four billion, eleven million, eight hundred and seventy-nine thousand, two hundred and sixty-four")
  , (806515533049393, "eight hundred and six trillion, five hundred and fifteen billion, five hundred and thirty-three million, forty-nine thousand, three hundred and ninety-three")
  , (1304969544928657, "one quadrillion, three hundred and four trillion, nine hundred and sixty-nine billion, five hundred and forty-four million, nine hundred and twenty-eight thousand, six hundred and fifty-seven")
  , (2111485077978050, "two quadrillion, one hundred and eleven trillion, four hundred and eighty-five billion, seventy-seven million, nine hundred and seventy-eight thousand and fifty")
  , (3416454622906707, "three quadrillion, four hundred and sixteen trillion, four hundred and fifty-four billion, six hundred and twenty-two million, nine hundred and six thousand, seven hundred and seven")
  , (5527939700884757, "five quadrillion, five hundred and twenty-seven trillion, nine hundred and thirty-nine billion, seven hundred million, eight hundred and eighty-four thousand, seven hundred and fifty-seven")
  , (8944394323791464, "eight quadrillion, nine hundred and forty-four trillion, three hundred and ninety-four billion, three hundred and twenty-three million, seven hundred and ninety-one thousand, four hundred and sixty-four")
  , (14472334024676221, "fourteen quadrillion, four hundred and seventy-two trillion, three hundred and thirty-four billion, twenty-four million, six hundred and seventy-six thousand, two hundred and twenty-one")
  , (23416728348467685, "twenty-three quadrillion, four hundred and sixteen trillion, seven hundred and twenty-eight billion, three hundred and forty-eight million, four hundred and sixty-seven thousand, six hundred and eighty-five")
  , (37889062373143906, "thirty-seven quadrillion, eight hundred and eighty-nine trillion, sixty-two billion, three hundred and seventy-three million, one hundred and forty-three thousand, nine hundred and six")
  , (61305790721611591, "sixty-one quadrillion, three hundred and five trillion, seven hundred and ninety billion, seven hundred and twenty-one million, six hundred and eleven thousand, five hundred and ninety-one")
  , (99194853094755497, "ninety-nine quadrillion, one hundred and ninety-four trillion, eight hundred and fifty-three billion, ninety-four million, seven hundred and fifty-five thousand, four hundred and ninety-seven")
  , (160500643816367088, "one hundred and sixty quadrillion, five hundred trillion, six hundred and forty-three billion, eight hundred and sixteen million, three hundred and sixty-seven thousand and eighty-eight")
  , (259695496911122585, "two hundred and fifty-nine quadrillion, six hundred and ninety-five trillion, four hundred and ninety-six billion, nine hundred and eleven million, one hundred and twenty-two thousand, five hundred and eighty-five")
  , (420196140727489673, "four hundred and twenty quadrillion, one hundred and ninety-six trillion, one hundred and forty billion, seven hundred and twenty-seven million, four hundred and eighty-nine thousand, six hundred and seventy-three")
  , (679891637638612258, "six hundred and seventy-nine quadrillion, eight hundred and ninety-one trillion, six hundred and thirty-seven billion, six hundred and thirty-eight million, six hundred and twelve thousand, two hundred and fifty-eight")
  , (1100087778366101931, "one quintillion, one hundred quadrillion, eighty-seven trillion, seven hundred and seventy-eight billion, three hundred and sixty-six million, one hundred and one thousand, nine hundred and thirty-one")
  , (1779979416004714189, "one quintillion, seven hundred and seventy-nine quadrillion, nine hundred and seventy-nine trillion, four hundred and sixteen billion, four million, seven hundred and fourteen thousand, one hundred and eighty-nine")
  , (2880067194370816120, "two quintillion, eight hundred and eighty quadrillion, sixty-seven trillion, one hundred and ninety-four billion, three hundred and seventy million, eight hundred and sixteen thousand, one hundred and twenty")
  , (4660046610375530309, "four quintillion, six hundred and sixty quadrillion, forty-six trillion, six hundred and ten billion, three hundred and seventy-five million, five hundred and thirty thousand, three hundred and nine")
  , (7540113804746346429, "seven quintillion, five hundred and forty quadrillion, one hundred and thirteen trillion, eight hundred and four billion, seven hundred and forty-six million, three hundred and forty-six thousand, four hundred and twenty-nine")
  , (12200160415121876738, "twelve quintillion, two hundred quadrillion, one hundred and sixty trillion, four hundred and fifteen billion, one hundred and twenty-one million, eight hundred and seventy-six thousand, seven hundred and thirty-eight")
  , (19740274219868223167, "nineteen quintillion, seven hundred and forty quadrillion, two hundred and seventy-four trillion, two hundred and nineteen billion, eight hundred and sixty-eight million, two hundred and twenty-three thousand, one hundred and sixty-seven")
  , (31940434634990099905, "thirty-one quintillion, nine hundred and forty quadrillion, four hundred and thirty-four trillion, six hundred and thirty-four billion, nine hundred and ninety million, ninety-nine thousand, nine hundred and five")
  , (51680708854858323072, "fifty-one quintillion, six hundred and eighty quadrillion, seven hundred and eight trillion, eight hundred and fifty-four billion, eight hundred and fifty-eight million, three hundred and twenty-three thousand and seventy-two")
  , (83621143489848422977, "eighty-three quintillion, six hundred and twenty-one quadrillion, one hundred and forty-three trillion, four hundred and eighty-nine billion, eight hundred and forty-eight million, four hundred and twenty-two thousand, nine hundred and seventy-seven")
  , (135301852344706746049, "one hundred and thirty-five quintillion, three hundred and one quadrillion, eight hundred and fifty-two trillion, three hundred and forty-four billion, seven hundred and six million, seven hundred and forty-six thousand and forty-nine")
  , (218922995834555169026, "two hundred and eighteen quintillion, nine hundred and twenty-two quadrillion, nine hundred and ninety-five trillion, eight hundred and thirty-four billion, five hundred and fifty-five million, one hundred and sixty-nine thousand and twenty-six")
  , (354224848179261915075, "three hundred and fifty-four quintillion, two hundred and twenty-four quadrillion, eight hundred and forty-eight trillion, one hundred and seventy-nine billion, two hundred and sixty-one million, nine hundred and fifteen thousand and seventy-five")
  , (573147844013817084101, "five hundred and seventy-three quintillion, one hundred and forty-seven quadrillion, eight hundred and forty-four trillion, thirteen billion, eight hundred and seventeen million, eighty-four thousand, one hundred and one")
  , (927372692193078999176, "nine hundred and twenty-seven quintillion, three hundred and seventy-two quadrillion, six hundred and ninety-two trillion, one hundred and ninety-three billion, seventy-eight million, nine hundred and ninety-nine thousand, one hundred and seventy-six")
  , (1500520536206896083277, "one sextillion, five hundred quintillion, five hundred and twenty quadrillion, five hundred and thirty-six trillion, two hundred and six billion, eight hundred and ninety-six million, eighty-three thousand, two hundred and seventy-seven")
  , (2427893228399975082453, "two sextillion, four hundred and twenty-seven quintillion, eight hundred and ninety-three quadrillion, two hundred and twenty-eight trillion, three hundred and ninety-nine billion, nine hundred and seventy-five million, eighty-two thousand, four hundred and fifty-three")
  , (3928413764606871165730, "three sextillion, nine hundred and twenty-eight quintillion, four hundred and thirteen quadrillion, seven hundred and sixty-four trillion, six hundred and six billion, eight hundred and seventy-one million, one hundred and sixty-five thousand, seven hundred and thirty")
  , (6356306993006846248183, "six sextillion, three hundred and fifty-six quintillion, three hundred and six quadrillion, nine hundred and ninety-three trillion, six billion, eight hundred and forty-six million, two hundred and forty-eight thousand, one hundred and eighty-three")
  , (10284720757613717413913, "ten sextillion, two hundred and eighty-four quintillion, seven hundred and twenty quadrillion, seven hundred and fifty-seven trillion, six hundred and thirteen billion, seven hundred and seventeen million, four hundred and thirteen thousand, nine hundred and thirteen")
  , (16641027750620563662096, "sixteen sextillion, six hundred and forty-one quintillion, twenty-seven quadrillion, seven hundred and fifty trillion, six hundred and twenty billion, five hundred and sixty-three million, six hundred and sixty-two thousand and ninety-six")
  , (26925748508234281076009, "twenty-six sextillion, nine hundred and twenty-five quintillion, seven hundred and forty-eight quadrillion, five hundred and eight trillion, two hundred and thirty-four billion, two hundred and eighty-one million, seventy-six thousand and nine")
  , (43566776258854844738105, "forty-three sextillion, five hundred and sixty-six quintillion, seven hundred and seventy-six quadrillion, two hundred and fifty-eight trillion, eight hundred and fifty-four billion, eight hundred and forty-four million, seven hundred and thirty-eight thousand, one hundred and five")
  , (70492524767089125814114, "seventy sextillion, four hundred and ninety-two quintillion, five hundred and twenty-four quadrillion, seven hundred and sixty-seven trillion, eighty-nine billion, one hundred and twenty-five million, eight hundred and fourteen thousand, one hundred and fourteen")
  , (114059301025943970552219, "one hundred and fourteen sextillion, fifty-nine quintillion, three hundred and one quadrillion, twenty-five trillion, nine hundred and forty-three billion, nine hundred and seventy million, five hundred and fifty-two thousand, two hundred and nineteen")
  , (1000, "one thousand")
  , (10000, "ten thousand")
  , (100000, "one hundred thousand")
  , (1000000, "one million")
  , (10000000, "ten million")
  , (100000000, "one hundred million")
  , (1000000000, "one billion")
  , (10000000000, "ten billion")
  , (100000000000, "one hundred billion")
  , (1000000000000, "one trillion")
  , (10000000000000, "ten trillion")
  , (100000000000000, "one hundred trillion")
  , (1000000000000000, "one quadrillion")
  , (10000000000000000, "ten quadrillion")
  , (100000000000000000, "one hundred quadrillion")
  , (1000000000000000000, "one quintillion")
  , (10000000000000000000, "ten quintillion")
  , (100000000000000000000, "one hundred quintillion")
  , (1000000000000000000000, "one sextillion")
  , (10000000000000000000000, "ten sextillion")
  , (100000000000000000000000, "one hundred sextillion")
  , (1000000000000000000000000, "one septillion")
  ]

ordinals :: [(Integer, Text)]
ordinals = [
    (0, "zeroth")
  , (1, "first")
  , (2, "second")
  , (3, "third")
  , (4, "fourth")
  , (5, "fifth")
  , (6, "sixth")
  , (7, "seventh")
  , (8, "eighth")
  , (9, "ninth")
  , (10, "tenth")
  , (11, "eleventh")
  , (12, "twelfth")
  , (13, "thirteenth")
  , (14, "fourteenth")
  , (15, "fifteenth")
  , (16, "sixteenth")
  , (17, "seventeenth")
  , (18, "eighteenth")
  , (19, "nineteenth")
  , (20, "twentieth")
  , (21, "twenty-first")
  , (22, "twenty-second")
  , (23, "twenty-third")
  , (24, "twenty-fourth")
  , (25, "twenty-fifth")
  , (26, "twenty-sixth")
  , (27, "twenty-seventh")
  , (28, "twenty-eighth")
  , (29, "twenty-ninth")
  , (30, "thirtieth")
  , (31, "thirty-first")
  , (32, "thirty-second")
  , (33, "thirty-third")
  , (34, "thirty-fourth")
  , (35, "thirty-fifth")
  , (36, "thirty-sixth")
  , (37, "thirty-seventh")
  , (38, "thirty-eighth")
  , (39, "thirty-ninth")
  , (40, "fortieth")
  , (41, "forty-first")
  , (42, "forty-second")
  , (43, "forty-third")
  , (44, "forty-fourth")
  , (45, "forty-fifth")
  , (46, "forty-sixth")
  , (47, "forty-seventh")
  , (48, "forty-eighth")
  , (49, "forty-ninth")
  , (50, "fiftieth")
  , (51, "fifty-first")
  , (52, "fifty-second")
  , (53, "fifty-third")
  , (54, "fifty-fourth")
  , (55, "fifty-fifth")
  , (56, "fifty-sixth")
  , (57, "fifty-seventh")
  , (58, "fifty-eighth")
  , (59, "fifty-ninth")
  , (60, "sixtieth")
  , (61, "sixty-first")
  , (62, "sixty-second")
  , (63, "sixty-third")
  , (64, "sixty-fourth")
  , (65, "sixty-fifth")
  , (66, "sixty-sixth")
  , (67, "sixty-seventh")
  , (68, "sixty-eighth")
  , (69, "sixty-ninth")
  , (70, "seventieth")
  , (71, "seventy-first")
  , (72, "seventy-second")
  , (73, "seventy-third")
  , (74, "seventy-fourth")
  , (75, "seventy-fifth")
  , (76, "seventy-sixth")
  , (77, "seventy-seventh")
  , (78, "seventy-eighth")
  , (79, "seventy-ninth")
  , (80, "eightieth")
  , (81, "eighty-first")
  , (82, "eighty-second")
  , (83, "eighty-third")
  , (84, "eighty-fourth")
  , (85, "eighty-fifth")
  , (86, "eighty-sixth")
  , (87, "eighty-seventh")
  , (88, "eighty-eighth")
  , (89, "eighty-ninth")
  , (90, "ninetieth")
  , (91, "ninety-first")
  , (92, "ninety-second")
  , (93, "ninety-third")
  , (94, "ninety-fourth")
  , (95, "ninety-fifth")
  , (96, "ninety-sixth")
  , (97, "ninety-seventh")
  , (98, "ninety-eighth")
  , (99, "ninety-ninth")
  , (100, "one hundredth")
  , (101, "one hundred and first")
  , (102, "one hundred and second")
  , (103, "one hundred and third")
  , (104, "one hundred and fourth")
  , (105, "one hundred and fifth")
  , (106, "one hundred and sixth")
  , (107, "one hundred and seventh")
  , (108, "one hundred and eighth")
  , (109, "one hundred and ninth")
  , (110, "one hundred and tenth")
  , (111, "one hundred and eleventh")
  , (112, "one hundred and twelfth")
  , (113, "one hundred and thirteenth")
  , (114, "one hundred and fourteenth")
  , (115, "one hundred and fifteenth")
  , (116, "one hundred and sixteenth")
  , (117, "one hundred and seventeenth")
  , (118, "one hundred and eighteenth")
  , (119, "one hundred and nineteenth")
  , (120, "one hundred and twentieth")
  , (121, "one hundred and twenty-first")
  , (122, "one hundred and twenty-second")
  , (123, "one hundred and twenty-third")
  , (124, "one hundred and twenty-fourth")
  , (125, "one hundred and twenty-fifth")
  , (126, "one hundred and twenty-sixth")
  , (127, "one hundred and twenty-seventh")
  , (128, "one hundred and twenty-eighth")
  , (129, "one hundred and twenty-ninth")
  , (130, "one hundred and thirtieth")
  , (131, "one hundred and thirty-first")
  , (132, "one hundred and thirty-second")
  , (133, "one hundred and thirty-third")
  , (134, "one hundred and thirty-fourth")
  , (135, "one hundred and thirty-fifth")
  , (136, "one hundred and thirty-sixth")
  , (137, "one hundred and thirty-seventh")
  , (138, "one hundred and thirty-eighth")
  , (139, "one hundred and thirty-ninth")
  , (140, "one hundred and fortieth")
  , (141, "one hundred and forty-first")
  , (142, "one hundred and forty-second")
  , (143, "one hundred and forty-third")
  , (144, "one hundred and forty-fourth")
  , (145, "one hundred and forty-fifth")
  , (146, "one hundred and forty-sixth")
  , (147, "one hundred and forty-seventh")
  , (148, "one hundred and forty-eighth")
  , (149, "one hundred and forty-ninth")
  , (150, "one hundred and fiftieth")
  , (151, "one hundred and fifty-first")
  , (152, "one hundred and fifty-second")
  , (153, "one hundred and fifty-third")
  , (154, "one hundred and fifty-fourth")
  , (155, "one hundred and fifty-fifth")
  , (156, "one hundred and fifty-sixth")
  , (157, "one hundred and fifty-seventh")
  , (158, "one hundred and fifty-eighth")
  , (159, "one hundred and fifty-ninth")
  , (160, "one hundred and sixtieth")
  , (161, "one hundred and sixty-first")
  , (162, "one hundred and sixty-second")
  , (163, "one hundred and sixty-third")
  , (164, "one hundred and sixty-fourth")
  , (165, "one hundred and sixty-fifth")
  , (166, "one hundred and sixty-sixth")
  , (167, "one hundred and sixty-seventh")
  , (168, "one hundred and sixty-eighth")
  , (169, "one hundred and sixty-ninth")
  , (170, "one hundred and seventieth")
  , (171, "one hundred and seventy-first")
  , (172, "one hundred and seventy-second")
  , (173, "one hundred and seventy-third")
  , (174, "one hundred and seventy-fourth")
  , (175, "one hundred and seventy-fifth")
  , (176, "one hundred and seventy-sixth")
  , (177, "one hundred and seventy-seventh")
  , (178, "one hundred and seventy-eighth")
  , (179, "one hundred and seventy-ninth")
  , (180, "one hundred and eightieth")
  , (181, "one hundred and eighty-first")
  , (182, "one hundred and eighty-second")
  , (183, "one hundred and eighty-third")
  , (184, "one hundred and eighty-fourth")
  , (185, "one hundred and eighty-fifth")
  , (186, "one hundred and eighty-sixth")
  , (187, "one hundred and eighty-seventh")
  , (188, "one hundred and eighty-eighth")
  , (189, "one hundred and eighty-ninth")
  , (190, "one hundred and ninetieth")
  , (191, "one hundred and ninety-first")
  , (192, "one hundred and ninety-second")
  , (193, "one hundred and ninety-third")
  , (194, "one hundred and ninety-fourth")
  , (195, "one hundred and ninety-fifth")
  , (196, "one hundred and ninety-sixth")
  , (197, "one hundred and ninety-seventh")
  , (198, "one hundred and ninety-eighth")
  , (199, "one hundred and ninety-ninth")
  , (200, "two hundredth")
  , (233, "two hundred and thirty-third")
  , (377, "three hundred and seventy-seventh")
  , (610, "six hundred and tenth")
  , (987, "nine hundred and eighty-seventh")
  , (1597, "one thousand, five hundred and ninety-seventh")
  , (2584, "two thousand, five hundred and eighty-fourth")
  , (4181, "four thousand, one hundred and eighty-first")
  , (6765, "six thousand, seven hundred and sixty-fifth")
  , (10946, "ten thousand, nine hundred and forty-sixth")
  , (17711, "seventeen thousand, seven hundred and eleventh")
  , (28657, "twenty-eight thousand, six hundred and fifty-seventh")
  , (46368, "forty-six thousand, three hundred and sixty-eighth")
  , (75025, "seventy-five thousand and twenty-fifth")
  , (121393, "one hundred and twenty-one thousand, three hundred and ninety-third")
  , (196418, "one hundred and ninety-six thousand, four hundred and eighteenth")
  , (317811, "three hundred and seventeen thousand, eight hundred and eleventh")
  , (514229, "five hundred and fourteen thousand, two hundred and twenty-ninth")
  , (832040, "eight hundred and thirty-two thousand and fortieth")
  , (1346269, "one million, three hundred and forty-six thousand, two hundred and sixty-ninth")
  , (2178309, "two million, one hundred and seventy-eight thousand, three hundred and ninth")
  , (3524578, "three million, five hundred and twenty-four thousand, five hundred and seventy-eighth")
  , (5702887, "five million, seven hundred and two thousand, eight hundred and eighty-seventh")
  , (9227465, "nine million, two hundred and twenty-seven thousand, four hundred and sixty-fifth")
  , (14930352, "fourteen million, nine hundred and thirty thousand, three hundred and fifty-second")
  , (24157817, "twenty-four million, one hundred and fifty-seven thousand, eight hundred and seventeenth")
  , (39088169, "thirty-nine million, eighty-eight thousand, one hundred and sixty-ninth")
  , (63245986, "sixty-three million, two hundred and forty-five thousand, nine hundred and eighty-sixth")
  , (102334155, "one hundred and two million, three hundred and thirty-four thousand, one hundred and fifty-fifth")
  , (165580141, "one hundred and sixty-five million, five hundred and eighty thousand, one hundred and forty-first")
  , (267914296, "two hundred and sixty-seven million, nine hundred and fourteen thousand, two hundred and ninety-sixth")
  , (433494437, "four hundred and thirty-three million, four hundred and ninety-four thousand, four hundred and thirty-seventh")
  , (701408733, "seven hundred and one million, four hundred and eight thousand, seven hundred and thirty-third")
  , (1134903170, "one billion, one hundred and thirty-four million, nine hundred and three thousand, one hundred and seventieth")
  , (1836311903, "one billion, eight hundred and thirty-six million, three hundred and eleven thousand, nine hundred and third")
  , (2971215073, "two billion, nine hundred and seventy-one million, two hundred and fifteen thousand and seventy-third")
  , (4807526976, "four billion, eight hundred and seven million, five hundred and twenty-six thousand, nine hundred and seventy-sixth")
  , (7778742049, "seven billion, seven hundred and seventy-eight million, seven hundred and forty-two thousand and forty-ninth")
  , (12586269025, "twelve billion, five hundred and eighty-six million, two hundred and sixty-nine thousand and twenty-fifth")
  , (20365011074, "twenty billion, three hundred and sixty-five million, eleven thousand and seventy-fourth")
  , (32951280099, "thirty-two billion, nine hundred and fifty-one million, two hundred and eighty thousand and ninety-ninth")
  , (53316291173, "fifty-three billion, three hundred and sixteen million, two hundred and ninety-one thousand, one hundred and seventy-third")
  , (86267571272, "eighty-six billion, two hundred and sixty-seven million, five hundred and seventy-one thousand, two hundred and seventy-second")
  , (139583862445, "one hundred and thirty-nine billion, five hundred and eighty-three million, eight hundred and sixty-two thousand, four hundred and forty-fifth")
  , (225851433717, "two hundred and twenty-five billion, eight hundred and fifty-one million, four hundred and thirty-three thousand, seven hundred and seventeenth")
  , (365435296162, "three hundred and sixty-five billion, four hundred and thirty-five million, two hundred and ninety-six thousand, one hundred and sixty-second")
  , (591286729879, "five hundred and ninety-one billion, two hundred and eighty-six million, seven hundred and twenty-nine thousand, eight hundred and seventy-ninth")
  , (956722026041, "nine hundred and fifty-six billion, seven hundred and twenty-two million, twenty-six thousand and forty-first")
  , (1548008755920, "one trillion, five hundred and forty-eight billion, eight million, seven hundred and fifty-five thousand, nine hundred and twentieth")
  , (2504730781961, "two trillion, five hundred and four billion, seven hundred and thirty million, seven hundred and eighty-one thousand, nine hundred and sixty-first")
  , (4052739537881, "four trillion, fifty-two billion, seven hundred and thirty-nine million, five hundred and thirty-seven thousand, eight hundred and eighty-first")
  , (6557470319842, "six trillion, five hundred and fifty-seven billion, four hundred and seventy million, three hundred and nineteen thousand, eight hundred and forty-second")
  , (10610209857723, "ten trillion, six hundred and ten billion, two hundred and nine million, eight hundred and fifty-seven thousand, seven hundred and twenty-third")
  , (17167680177565, "seventeen trillion, one hundred and sixty-seven billion, six hundred and eighty million, one hundred and seventy-seven thousand, five hundred and sixty-fifth")
  , (27777890035288, "twenty-seven trillion, seven hundred and seventy-seven billion, eight hundred and ninety million, thirty-five thousand, two hundred and eighty-eighth")
  , (44945570212853, "forty-four trillion, nine hundred and forty-five billion, five hundred and seventy million, two hundred and twelve thousand, eight hundred and fifty-third")
  , (72723460248141, "seventy-two trillion, seven hundred and twenty-three billion, four hundred and sixty million, two hundred and forty-eight thousand, one hundred and forty-first")
  , (117669030460994, "one hundred and seventeen trillion, six hundred and sixty-nine billion, thirty million, four hundred and sixty thousand, nine hundred and ninety-fourth")
  , (190392490709135, "one hundred and ninety trillion, three hundred and ninety-two billion, four hundred and ninety million, seven hundred and nine thousand, one hundred and thirty-fifth")
  , (308061521170129, "three hundred and eight trillion, sixty-one billion, five hundred and twenty-one million, one hundred and seventy thousand, one hundred and twenty-ninth")
  , (498454011879264, "four hundred and ninety-eight trillion, four hundred and fifty-four billion, eleven million, eight hundred and seventy-nine thousand, two hundred and sixty-fourth")
  , (806515533049393, "eight hundred and six trillion, five hundred and fifteen billion, five hundred and thirty-three million, forty-nine thousand, three hundred and ninety-third")
  , (1304969544928657, "one quadrillion, three hundred and four trillion, nine hundred and sixty-nine billion, five hundred and forty-four million, nine hundred and twenty-eight thousand, six hundred and fifty-seventh")
  , (2111485077978050, "two quadrillion, one hundred and eleven trillion, four hundred and eighty-five billion, seventy-seven million, nine hundred and seventy-eight thousand and fiftieth")
  , (3416454622906707, "three quadrillion, four hundred and sixteen trillion, four hundred and fifty-four billion, six hundred and twenty-two million, nine hundred and six thousand, seven hundred and seventh")
  , (5527939700884757, "five quadrillion, five hundred and twenty-seven trillion, nine hundred and thirty-nine billion, seven hundred million, eight hundred and eighty-four thousand, seven hundred and fifty-seventh")
  , (8944394323791464, "eight quadrillion, nine hundred and forty-four trillion, three hundred and ninety-four billion, three hundred and twenty-three million, seven hundred and ninety-one thousand, four hundred and sixty-fourth")
  , (14472334024676221, "fourteen quadrillion, four hundred and seventy-two trillion, three hundred and thirty-four billion, twenty-four million, six hundred and seventy-six thousand, two hundred and twenty-first")
  , (23416728348467685, "twenty-three quadrillion, four hundred and sixteen trillion, seven hundred and twenty-eight billion, three hundred and forty-eight million, four hundred and sixty-seven thousand, six hundred and eighty-fifth")
  , (37889062373143906, "thirty-seven quadrillion, eight hundred and eighty-nine trillion, sixty-two billion, three hundred and seventy-three million, one hundred and forty-three thousand, nine hundred and sixth")
  , (61305790721611591, "sixty-one quadrillion, three hundred and five trillion, seven hundred and ninety billion, seven hundred and twenty-one million, six hundred and eleven thousand, five hundred and ninety-first")
  , (99194853094755497, "ninety-nine quadrillion, one hundred and ninety-four trillion, eight hundred and fifty-three billion, ninety-four million, seven hundred and fifty-five thousand, four hundred and ninety-seventh")
  , (160500643816367088, "one hundred and sixty quadrillion, five hundred trillion, six hundred and forty-three billion, eight hundred and sixteen million, three hundred and sixty-seven thousand and eighty-eighth")
  , (259695496911122585, "two hundred and fifty-nine quadrillion, six hundred and ninety-five trillion, four hundred and ninety-six billion, nine hundred and eleven million, one hundred and twenty-two thousand, five hundred and eighty-fifth")
  , (420196140727489673, "four hundred and twenty quadrillion, one hundred and ninety-six trillion, one hundred and forty billion, seven hundred and twenty-seven million, four hundred and eighty-nine thousand, six hundred and seventy-third")
  , (679891637638612258, "six hundred and seventy-nine quadrillion, eight hundred and ninety-one trillion, six hundred and thirty-seven billion, six hundred and thirty-eight million, six hundred and twelve thousand, two hundred and fifty-eighth")
  , (1100087778366101931, "one quintillion, one hundred quadrillion, eighty-seven trillion, seven hundred and seventy-eight billion, three hundred and sixty-six million, one hundred and one thousand, nine hundred and thirty-first")
  , (1779979416004714189, "one quintillion, seven hundred and seventy-nine quadrillion, nine hundred and seventy-nine trillion, four hundred and sixteen billion, four million, seven hundred and fourteen thousand, one hundred and eighty-ninth")
  , (2880067194370816120, "two quintillion, eight hundred and eighty quadrillion, sixty-seven trillion, one hundred and ninety-four billion, three hundred and seventy million, eight hundred and sixteen thousand, one hundred and twentieth")
  , (4660046610375530309, "four quintillion, six hundred and sixty quadrillion, forty-six trillion, six hundred and ten billion, three hundred and seventy-five million, five hundred and thirty thousand, three hundred and ninth")
  , (7540113804746346429, "seven quintillion, five hundred and forty quadrillion, one hundred and thirteen trillion, eight hundred and four billion, seven hundred and forty-six million, three hundred and forty-six thousand, four hundred and twenty-ninth")
  , (12200160415121876738, "twelve quintillion, two hundred quadrillion, one hundred and sixty trillion, four hundred and fifteen billion, one hundred and twenty-one million, eight hundred and seventy-six thousand, seven hundred and thirty-eighth")
  , (19740274219868223167, "nineteen quintillion, seven hundred and forty quadrillion, two hundred and seventy-four trillion, two hundred and nineteen billion, eight hundred and sixty-eight million, two hundred and twenty-three thousand, one hundred and sixty-seventh")
  , (31940434634990099905, "thirty-one quintillion, nine hundred and forty quadrillion, four hundred and thirty-four trillion, six hundred and thirty-four billion, nine hundred and ninety million, ninety-nine thousand, nine hundred and fifth")
  , (51680708854858323072, "fifty-one quintillion, six hundred and eighty quadrillion, seven hundred and eight trillion, eight hundred and fifty-four billion, eight hundred and fifty-eight million, three hundred and twenty-three thousand and seventy-second")
  , (83621143489848422977, "eighty-three quintillion, six hundred and twenty-one quadrillion, one hundred and forty-three trillion, four hundred and eighty-nine billion, eight hundred and forty-eight million, four hundred and twenty-two thousand, nine hundred and seventy-seventh")
  , (135301852344706746049, "one hundred and thirty-five quintillion, three hundred and one quadrillion, eight hundred and fifty-two trillion, three hundred and forty-four billion, seven hundred and six million, seven hundred and forty-six thousand and forty-ninth")
  , (218922995834555169026, "two hundred and eighteen quintillion, nine hundred and twenty-two quadrillion, nine hundred and ninety-five trillion, eight hundred and thirty-four billion, five hundred and fifty-five million, one hundred and sixty-nine thousand and twenty-sixth")
  , (354224848179261915075, "three hundred and fifty-four quintillion, two hundred and twenty-four quadrillion, eight hundred and forty-eight trillion, one hundred and seventy-nine billion, two hundred and sixty-one million, nine hundred and fifteen thousand and seventy-fifth")
  , (573147844013817084101, "five hundred and seventy-three quintillion, one hundred and forty-seven quadrillion, eight hundred and forty-four trillion, thirteen billion, eight hundred and seventeen million, eighty-four thousand, one hundred and first")
  , (927372692193078999176, "nine hundred and twenty-seven quintillion, three hundred and seventy-two quadrillion, six hundred and ninety-two trillion, one hundred and ninety-three billion, seventy-eight million, nine hundred and ninety-nine thousand, one hundred and seventy-sixth")
  , (1500520536206896083277, "one sextillion, five hundred quintillion, five hundred and twenty quadrillion, five hundred and thirty-six trillion, two hundred and six billion, eight hundred and ninety-six million, eighty-three thousand, two hundred and seventy-seventh")
  , (2427893228399975082453, "two sextillion, four hundred and twenty-seven quintillion, eight hundred and ninety-three quadrillion, two hundred and twenty-eight trillion, three hundred and ninety-nine billion, nine hundred and seventy-five million, eighty-two thousand, four hundred and fifty-third")
  , (3928413764606871165730, "three sextillion, nine hundred and twenty-eight quintillion, four hundred and thirteen quadrillion, seven hundred and sixty-four trillion, six hundred and six billion, eight hundred and seventy-one million, one hundred and sixty-five thousand, seven hundred and thirtieth")
  , (6356306993006846248183, "six sextillion, three hundred and fifty-six quintillion, three hundred and six quadrillion, nine hundred and ninety-three trillion, six billion, eight hundred and forty-six million, two hundred and forty-eight thousand, one hundred and eighty-third")
  , (10284720757613717413913, "ten sextillion, two hundred and eighty-four quintillion, seven hundred and twenty quadrillion, seven hundred and fifty-seven trillion, six hundred and thirteen billion, seven hundred and seventeen million, four hundred and thirteen thousand, nine hundred and thirteenth")
  , (16641027750620563662096, "sixteen sextillion, six hundred and forty-one quintillion, twenty-seven quadrillion, seven hundred and fifty trillion, six hundred and twenty billion, five hundred and sixty-three million, six hundred and sixty-two thousand and ninety-sixth")
  , (26925748508234281076009, "twenty-six sextillion, nine hundred and twenty-five quintillion, seven hundred and forty-eight quadrillion, five hundred and eight trillion, two hundred and thirty-four billion, two hundred and eighty-one million, seventy-six thousand and ninth")
  , (43566776258854844738105, "forty-three sextillion, five hundred and sixty-six quintillion, seven hundred and seventy-six quadrillion, two hundred and fifty-eight trillion, eight hundred and fifty-four billion, eight hundred and forty-four million, seven hundred and thirty-eight thousand, one hundred and fifth")
  , (70492524767089125814114, "seventy sextillion, four hundred and ninety-two quintillion, five hundred and twenty-four quadrillion, seven hundred and sixty-seven trillion, eighty-nine billion, one hundred and twenty-five million, eight hundred and fourteen thousand, one hundred and fourteenth")
  , (114059301025943970552219, "one hundred and fourteen sextillion, fifty-nine quintillion, three hundred and one quadrillion, twenty-five trillion, nine hundred and forty-three billion, nine hundred and seventy million, five hundred and fifty-two thousand, two hundred and nineteenth")
  , (1000, "one thousandth")
  , (10000, "ten thousandth")
  , (100000, "one hundred thousandth")
  , (1000000, "one millionth")
  , (10000000, "ten millionth")
  , (100000000, "one hundred millionth")
  , (1000000000, "one billionth")
  , (10000000000, "ten billionth")
  , (100000000000, "one hundred billionth")
  , (1000000000000, "one trillionth")
  , (10000000000000, "ten trillionth")
  , (100000000000000, "one hundred trillionth")
  , (1000000000000000, "one quadrillionth")
  , (10000000000000000, "ten quadrillionth")
  , (100000000000000000, "one hundred quadrillionth")
  , (1000000000000000000, "one quintillionth")
  , (10000000000000000000, "ten quintillionth")
  , (100000000000000000000, "one hundred quintillionth")
  , (1000000000000000000000, "one sextillionth")
  , (10000000000000000000000, "ten sextillionth")
  , (100000000000000000000000, "one hundred sextillionth")
  , (1000000000000000000000000, "one septillionth")
  ]
